package net.mcreator.mcmagic.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.11.2
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelognisty<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(ResourceLocation.fromNamespaceAndPath("mcmagic", "modelognisty"), "main");
	public final ModelPart cialo;
	public final ModelPart lewanoga;
	public final ModelPart lewareka;
	public final ModelPart prawareka;
	public final ModelPart prawanoga;
	public final ModelPart glowa;

	public Modelognisty(ModelPart root) {
		this.cialo = root.getChild("cialo");
		this.lewanoga = this.cialo.getChild("lewanoga");
		this.lewareka = this.cialo.getChild("lewareka");
		this.prawareka = this.cialo.getChild("prawareka");
		this.prawanoga = this.cialo.getChild("prawanoga");
		this.glowa = this.cialo.getChild("glowa");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition cialo = partdefinition.addOrReplaceChild("cialo", CubeListBuilder.create().texOffs(0, 0).addBox(-10.0F, -18.0F, -6.0F, 21.0F, 23.0F, 12.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -10.0F, 0.0F));
		PartDefinition lewanoga = cialo.addOrReplaceChild("lewanoga", CubeListBuilder.create().texOffs(67, 0).addBox(-14.0F, 14.0F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)), PartPose.offset(-8.0F, 5.0F, 0.0F));
		PartDefinition cube_r1 = lewanoga.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(0, 69).addBox(-6.0F, -15.0F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-8.0F, 14.0F, 0.0F, 0.0F, 0.0F, 0.2182F));
		PartDefinition lewareka = cialo.addOrReplaceChild("lewareka", CubeListBuilder.create().texOffs(98, 92).addBox(-14.1865F, 12.8205F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-9.0F, -12.0F, 0.0F, 0.0F, 0.0F, 0.5236F));
		PartDefinition cube_r2 = lewareka.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(114, 28).addBox(-6.0F, -15.0F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-8.1865F, 12.8205F, 0.0F, 0.0F, 0.0F, 0.2182F));
		PartDefinition prawareka = cialo.addOrReplaceChild("prawareka", CubeListBuilder.create().texOffs(49, 92).addBox(-15.1893F, 13.3823F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(8.0F, -11.0F, 0.0F, -3.1416F, 0.0F, 2.5744F));
		PartDefinition cube_r3 = prawareka.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(0, 97).addBox(-6.0F, -15.0F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-9.1893F, 13.3823F, 0.0F, 0.0F, 0.0F, 0.2182F));
		PartDefinition prawanoga = cialo.addOrReplaceChild("prawanoga", CubeListBuilder.create().texOffs(65, 36).addBox(-12.0F, 16.0F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(10.0F, 3.0F, 0.0F, -3.1416F, 0.0F, 3.1416F));
		PartDefinition cube_r4 = prawanoga.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(65, 64).addBox(-6.0F, -15.0F, -6.0F, 12.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-6.0F, 16.0F, 0.0F, 0.0F, 0.0F, 0.2182F));
		PartDefinition glowa = cialo.addOrReplaceChild("glowa", CubeListBuilder.create().texOffs(0, 36).addBox(-15.0F, -16.0F, -12.0F, 16.0F, 16.0F, 16.0F, new CubeDeformation(0.0F)), PartPose.offset(8.0F, -18.0F, 5.0F));
		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, int rgb) {
		cialo.render(poseStack, vertexConsumer, packedLight, packedOverlay, rgb);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		this.lewanoga.yRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.prawanoga.yRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.glowa.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.glowa.xRot = headPitch / (180F / (float) Math.PI);
		this.lewareka.yRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.prawareka.yRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
	}
}
