
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.mcmagic.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.event.entity.RegisterSpawnPlacementsEvent;
import net.neoforged.neoforge.event.entity.EntityAttributeCreationEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;
import net.minecraft.core.registries.Registries;

import net.mcreator.mcmagic.entity.OgnistyEntity;
import net.mcreator.mcmagic.entity.MrorzonyEntity;
import net.mcreator.mcmagic.entity.KulamagipociskEntity;
import net.mcreator.mcmagic.entity.IcearrowEntity;
import net.mcreator.mcmagic.entity.FirearrowEntity;
import net.mcreator.mcmagic.entity.ElectrickarrowEntity;
import net.mcreator.mcmagic.entity.DuchEntity;
import net.mcreator.mcmagic.McmagicMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class McmagicModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(Registries.ENTITY_TYPE, McmagicMod.MODID);
	public static final DeferredHolder<EntityType<?>, EntityType<FirearrowEntity>> FIREARROW = register("firearrow",
			EntityType.Builder.<FirearrowEntity>of(FirearrowEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<IcearrowEntity>> ICEARROW = register("icearrow",
			EntityType.Builder.<IcearrowEntity>of(IcearrowEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<ElectrickarrowEntity>> ELECTRICKARROW = register("electrickarrow",
			EntityType.Builder.<ElectrickarrowEntity>of(ElectrickarrowEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<OgnistyEntity>> OGNISTY = register("ognisty",
			EntityType.Builder.<OgnistyEntity>of(OgnistyEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(3f, 4f));
	public static final DeferredHolder<EntityType<?>, EntityType<KulamagipociskEntity>> KULAMAGIPOCISK = register("kulamagipocisk",
			EntityType.Builder.<KulamagipociskEntity>of(KulamagipociskEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<MrorzonyEntity>> MRORZONY = register("mrorzony",
			EntityType.Builder.<MrorzonyEntity>of(MrorzonyEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(3f, 4f));
	public static final DeferredHolder<EntityType<?>, EntityType<DuchEntity>> DUCH = register("duch",
			EntityType.Builder.<DuchEntity>of(DuchEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));

	// Start of user code block custom entities
	// End of user code block custom entities
	private static <T extends Entity> DeferredHolder<EntityType<?>, EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(registryname));
	}

	@SubscribeEvent
	public static void init(RegisterSpawnPlacementsEvent event) {
		OgnistyEntity.init(event);
		MrorzonyEntity.init(event);
		DuchEntity.init(event);
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(OGNISTY.get(), OgnistyEntity.createAttributes().build());
		event.put(MRORZONY.get(), MrorzonyEntity.createAttributes().build());
		event.put(DUCH.get(), DuchEntity.createAttributes().build());
	}
}
