
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.mcmagic.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.event.BuildCreativeModeTabContentsEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.CreativeModeTabs;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.network.chat.Component;
import net.minecraft.core.registries.Registries;

import net.mcreator.mcmagic.McmagicMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class McmagicModTabs {
	public static final DeferredRegister<CreativeModeTab> REGISTRY = DeferredRegister.create(Registries.CREATIVE_MODE_TAB, McmagicMod.MODID);
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> MAGICKITEMS = REGISTRY.register("magickitems",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.mcmagic.magickitems")).icon(() -> new ItemStack(McmagicModItems.OGNISTASTRZALA.get())).displayItems((parameters, tabData) -> {
				tabData.accept(McmagicModItems.OGNISTASTRZALA.get());
				tabData.accept(McmagicModItems.OGNISTYLUK.get());
				tabData.accept(McmagicModItems.LODOWASTRZALA.get());
				tabData.accept(McmagicModItems.LODOWYLUK.get());
				tabData.accept(McmagicModItems.MAGICZNYMIECZ.get());
				tabData.accept(McmagicModItems.ELEKTRYCZNASTRZALA.get());
				tabData.accept(McmagicModItems.ELEKTRYCZNYLUK.get());
				tabData.accept(McmagicModItems.RURZCZKA.get());
				tabData.accept(McmagicModItems.MAGICZNA_HELMET.get());
				tabData.accept(McmagicModItems.MAGICZNA_CHESTPLATE.get());
				tabData.accept(McmagicModItems.MAGICZNA_LEGGINGS.get());
				tabData.accept(McmagicModItems.MAGICZNA_BOOTS.get());
				tabData.accept(McmagicModItems.SPECIALNA_HELMET.get());
				tabData.accept(McmagicModItems.SPECIALNA_CHESTPLATE.get());
				tabData.accept(McmagicModItems.SPECIALNA_LEGGINGS.get());
				tabData.accept(McmagicModItems.SPECIALNA_BOOTS.get());
				tabData.accept(McmagicModItems.KULAMAGI.get());
				tabData.accept(McmagicModItems.MOTYKADUCHA.get());
				tabData.accept(McmagicModItems.MEGAMIECZ.get());
			}).build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> MAGICZNEBLOKI = REGISTRY.register("magicznebloki",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.mcmagic.magicznebloki")).icon(() -> new ItemStack(McmagicModBlocks.OGNISTECEGLY.get())).displayItems((parameters, tabData) -> {
				tabData.accept(McmagicModBlocks.OGNISTECEGLY.get().asItem());
				tabData.accept(McmagicModBlocks.OGNISTYKAMIEN.get().asItem());
				tabData.accept(McmagicModBlocks.KORONA.get().asItem());
				tabData.accept(McmagicModBlocks.OGNISTYBRUK.get().asItem());
				tabData.accept(McmagicModBlocks.POR.get().asItem());
				tabData.accept(McmagicModBlocks.AKTYWNYPORTAL.get().asItem());
				tabData.accept(McmagicModBlocks.LODOWECEGLY.get().asItem());
				tabData.accept(McmagicModBlocks.MAGICZNYSTUL.get().asItem());
				tabData.accept(McmagicModBlocks.SPAWNPOINT.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_WOOD.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_LOG.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_PLANKS.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_LEAVES.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_STAIRS.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_SLAB.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_FENCE.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_PRESSURE_PLATE.get().asItem());
				tabData.accept(McmagicModBlocks.ROZ_ZARZONE_BUTTON.get().asItem());
				tabData.accept(McmagicModBlocks.BRAMAOGNIA.get().asItem());
			}).withTabsBefore(MAGICKITEMS.getId()).build());

	@SubscribeEvent
	public static void buildTabContentsVanilla(BuildCreativeModeTabContentsEvent tabData) {
		if (tabData.getTabKey() == CreativeModeTabs.SPAWN_EGGS) {
			tabData.accept(McmagicModItems.OGNISTY_SPAWN_EGG.get());
			tabData.accept(McmagicModItems.MRORZONY_SPAWN_EGG.get());
			tabData.accept(McmagicModItems.DUCH_SPAWN_EGG.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.NATURAL_BLOCKS) {
			tabData.accept(McmagicModBlocks.ENDERDRZEWO.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_LEAVES.get().asItem());
		} else if (tabData.getTabKey() == CreativeModeTabs.INGREDIENTS) {
			tabData.accept(McmagicModItems.ENDERPATYK.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.BUILDING_BLOCKS) {
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_WOOD.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_LOG.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_PLANKS.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_STAIRS.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_SLAB.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_FENCE.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_FENCE_GATE.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_PRESSURE_PLATE.get().asItem());
			tabData.accept(McmagicModBlocks.ROZ_ZARZONE_BUTTON.get().asItem());
		} else if (tabData.getTabKey() == CreativeModeTabs.FOOD_AND_DRINKS) {
			tabData.accept(McmagicModItems.PODEJRZANYCHLEB.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.COMBAT) {
			tabData.accept(McmagicModItems.COPPERBOW.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.FUNCTIONAL_BLOCKS) {
			tabData.accept(McmagicModBlocks.LADOWARKA_1.get().asItem());
		}
	}
}
