package net.mcreator.mcmagic.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.mcmagic.world.inventory.MagiczcznyMenu;
import net.mcreator.mcmagic.network.MagiczcznyButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class MagiczcznyScreen extends AbstractContainerScreen<MagiczcznyMenu> {
	private final static HashMap<String, Object> guistate = MagiczcznyMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_level_1;
	ImageButton imagebutton_strzalka;
	ImageButton imagebutton_ender_stick1;

	public MagiczcznyScreen(MagiczcznyMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("mcmagic:textures/screens/magiczczny.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);

		guiGraphics.blit(ResourceLocation.parse("mcmagic:textures/screens/strzalka.png"), this.leftPos + 29, this.topPos + 33, 0, 0, 16, 16, 16, 16);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.mcmagic.magiczczny.label_10"), 48, 12, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.mcmagic.magiczczny.label_100"), 49, 36, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_level_1 = new ImageButton(this.leftPos + 7, this.topPos + 9, 16, 16, new WidgetSprites(ResourceLocation.parse("mcmagic:textures/screens/level_1.png"), ResourceLocation.parse("mcmagic:textures/screens/magia.png")), e -> {
			if (true) {
				PacketDistributor.sendToServer(new MagiczcznyButtonMessage(0, x, y, z));
				MagiczcznyButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_level_1", imagebutton_level_1);
		this.addRenderableWidget(imagebutton_level_1);
		imagebutton_strzalka = new ImageButton(this.leftPos + 29, this.topPos + 9, 16, 16, new WidgetSprites(ResourceLocation.parse("mcmagic:textures/screens/strzalka.png"), ResourceLocation.parse("mcmagic:textures/screens/strzalka.png")), e -> {
		}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_strzalka", imagebutton_strzalka);
		this.addRenderableWidget(imagebutton_strzalka);
		imagebutton_ender_stick1 = new ImageButton(this.leftPos + 8, this.topPos + 33, 16, 16, new WidgetSprites(ResourceLocation.parse("mcmagic:textures/screens/ender_stick1.png"), ResourceLocation.parse("mcmagic:textures/screens/magia.png")),
				e -> {
					if (true) {
						PacketDistributor.sendToServer(new MagiczcznyButtonMessage(2, x, y, z));
						MagiczcznyButtonMessage.handleButtonAction(entity, 2, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_ender_stick1", imagebutton_ender_stick1);
		this.addRenderableWidget(imagebutton_ender_stick1);
	}
}
